Markdown to HTML preview in EJ2 JavaScript Markdown Editor Control

22 Mar 202513 minutes to read

The Markdown Editor provides an instant preview of Markdown changes, allowing users to see the formatted output while typing or editing text. This enhances the editing experience by enabling real-time visualization of Markdown formatting.

Enable Markdown Preview in EJ2 JavaScript Markdown Editor

To enable the Markdown preview feature, integrate the third-party Marked library, which converts Markdown content into HTML format. The following example demonstrates how to enable Markdown to HTML preview in the Markdown Editor.

ej.base.enableRipple(true);

var textArea;
var srcArea;

var splitObj = new ej.layouts.Splitter({
  height: '450px',
  resizing: onResizing,
  created: updateOrientation,
  width: '100%',
  paneSettings: [
    {
      resizable: true,
      size: '50%',
      min: '40%',
    },
    { min: '40%' },
  ],
});
splitObj.appendTo('#splitter-rte-markdown-preview');

var markdownRTE = new ej.richtexteditor.RichTextEditor({
  height: '100%',
  value:
    'In Rich Text Editor, you click the toolbar buttons to format the words and the changes are visible immediately. Markdown is not like that. When you format the word in Markdown format, you need to add Markdown syntax to the word to indicate which words and phrases should look different from each other. Rich Text Editor supports markdown editing when the editorMode set as **markdown** and using both *keyboard interaction* and *toolbar action*, you can apply the formatting to text. You can add our own custom formation syntax for the Markdown formation, [sample link](https://ej2.syncfusion.com/home/). The third-party library <b>Marked</b> is used in this sample to convert markdown into HTML content.',
  placeholder: 'Enter your text here...',
  floatingToolbarOffset: 0,
  editorMode: 'Markdown',
  toolbarSettings: {
    type: 'Expand',
    enableFloating: false,
    items: [
      'Bold',
      'Italic',
      'StrikeThrough',
      '|',
      'Formats',
      'Blockquote',
      'OrderedList',
      'UnorderedList',
      '|',
      'CreateLink',
      'Image',
      'CreateTable',
      '|',
      'Undo',
      'Redo',
    ],
  },
  saveInterval: 1,
  actionComplete: updateValue,
  change: onChange,
  showCharCount: true,
  maxLength: 5000,
  created: onCreate,
});
markdownRTE.appendTo('#markdown-editor');

function onChange() {
  updateValue();
}
function onResizing() {
  markdownRTE.refreshUI();
}
function onCreate() {
  loadExternalFile();
  textArea = markdownRTE.contentModule.getEditPanel();
  srcArea = document.querySelector('.source-code');
}
function updateValue() {
  srcArea.innerHTML = marked(markdownRTE.contentModule.getEditPanel().value);
}
function updateOrientation() {
  if (ej.base.Browser.isDevice) {
    splitObj.orientation = 'Vertical';
    document.body.querySelector('.heading').style.width = 'auto';
  }
}
function loadExternalFile() {
  var script = document.createElement('script');
  script.type = 'text/javascript';
  script.src = 'https://cdnjs.cloudflare.com/ajax/libs/marked/0.3.19/marked.js';
  script.onload = function () {
    updateValue();
  };
  document.getElementsByTagName('head')[0].appendChild(script);
}
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2 Rich Text Editor</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-richtexteditor/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-navigations/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-layouts/styles/material.css" rel="stylesheet" />
    
   
<script src="https://cdn.syncfusion.com/ej2/32.1.19/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div class="default-section">
            <div id="splitter-rte-markdown-preview">
              <div class="splitter-default-content pane1">
                <div id="markdown-editor"></div>
              </div>
              <div class="heading right">
                <div>
                  <h6 class="title"><b>Markdown Preview</b></h6>
                </div>
                <div
                  class="splitter-default-content source-code pane2"
                  style="padding: 20px"
                ></div>
              </div>
            </div>
          </div>
    </div>
    <style>
        .heading {
        float: left;
        width: 50%;
        position: relative;
        box-sizing: border-box;
        padding: 0px;
        padding-left: 0px;
        padding-right: 0px;
      }
      .title {
        color: #333333;
        letter-spacing: 1px;
        padding-left: 10px;
        text-align: center;
        margin: 15px 0;
      }
      .e-richtexteditor textarea.e-content {
        float: left;
        border-right: 1px solid rgba(0, 0, 0, 0.12);
      }
      .e-richtexteditor .e-rte-content .e-content {
        min-height: 150px;
      }

      .e-richtexteditor .e-rte-content {
        overflow: hidden;
      }
      .bootstrap4 .e-icon-btn.e-active .e-md-preview::before {
        content: '\e790';
      }

      .bootstrap4 .e-icon-btn .e-md-preview::before {
        content: '\e787';
      }

      .tailwind .e-icon-btn.e-active .e-md-preview::before,
      .tailwind-dark .e-icon-btn.e-active .e-md-preview::before,
      .tailwind3 .e-icon-btn.e-active .e-md-preview::before,
      .tailwind3-dark .e-icon-btn.e-active .e-md-preview::before,
      .fluent .e-icon-btn.e-active .e-md-preview::before,
      .fluent-dark .e-icon-btn.e-active .e-md-preview::before,
      .fluent2 .e-icon-btn.e-active .e-md-preview::before,
      .fluent2-dark .e-icon-btn.e-active .e-md-preview::before,
      .bootstrap5 .e-icon-btn.e-active .e-md-preview::before,
      .bootstrap5\.3 .e-icon-btn.e-active .e-md-preview::before,
      .bootstrap5\.3-dark .e-icon-btn.e-active .e-md-preview::before,
      .bootstrap5-dark .e-icon-btn.e-active .e-md-preview::before,
      .material3 .e-icon-btn.e-active .e-md-preview::before,
      .material3-dark .e-icon-btn.e-active .e-md-preview::before {
        content: '\e80e';
      }

      .tailwind .e-icon-btn .e-md-preview::before,
      .tailwind-dark .e-icon-btn .e-md-preview::before,
      .tailwind3 .e-icon-btn .e-md-preview::before,
      .tailwind3-dark .e-icon-btn .e-md-preview::before,
      .bootstrap5 .e-icon-btn .e-md-preview::before,
      .bootstrap5\.3 .e-icon-btn .e-md-preview::before,
      .bootstrap5\.3-dark .e-icon-btn .e-md-preview::before,
      .bootstrap5-dark .e-icon-btn .e-md-preview::before,
      .fluent .e-icon-btn .e-md-preview::before,
      .fluent-dark .e-icon-btn .e-md-preview::before,
      .fluent2 .e-icon-btn .e-md-preview::before,
      .fluent2-dark .e-icon-btn .e-md-preview::before,
      .material3 .e-icon-btn .e-md-preview::before,
      .material3-dark .e-icon-btn .e-md-preview::before {
        content: '\e7de';
      }

      .e-icon-btn.e-active .e-md-preview::before {
        content: '\e350';
      }

      .e-icon-btn .e-md-preview::before {
        content: '\e345';
      }

      .e-rte-content .e-content {
        float: right;
        width: 50%;
        overflow: auto;
        height: inherit;
        padding: 8px;
        height: 100%;
      }

      .e-rte-content .e-content.e-pre-source {
        width: 100%;
      }

      .highcontrast .e-richtexteditor textarea.e-content {
        border-right: 1px solid #fff;
      }
    </style>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Markdown Preview in Angular Markdown Editor Component

29 Aug 20258 minutes to read

The Markdown Editor provides an instant preview of Markdown changes, allowing users to see the formatted output while typing or editing text. This enhances the editing experience by enabling real-time visualization of Markdown formatting.

Enable Markdown Preview in Angular Markdown Editor

To enable the Markdown preview feature, integrate the third-party Marked library, which converts Markdown content into HTML format. The following example demonstrates how to enable Markdown to HTML preview in the Syncfusion Angular Markdown Editor.

import { enableRipple } from '@syncfusion/ej2-base';
import { Component, ViewChild } from '@angular/core';
import {
  RichTextEditorModule,
  ToolbarSettingsModel,
  RichTextEditorComponent,
  ContentRender,
  ToolbarService,
  LinkService,
  ImageService,
  MarkdownEditorService,
  TableService,
  EditorMode,
} from '@syncfusion/ej2-angular-richtexteditor';
import { Browser } from '@syncfusion/ej2-base';
import { marked } from 'marked';
import {
  SplitterComponent,
  SplitterModule,
} from '@syncfusion/ej2-angular-layouts';
enableRipple(true);

@Component({
    imports: [RichTextEditorModule, SplitterModule],
    standalone: true,
    selector: 'app-root',
    template: ` <div class="sample-container markdown-preview"><ejs-splitter id="splitter-rte-markdown-preview" #splitterInstance height='450px' width='100%' (resizing)="resizing()" (created)='updateOrientation()'>
    <e-panes>
        <e-pane size='50%' [resizable]='true' cssClass='pane1' min='40%' >
            <ng-template #content>
                <div class="content">
                    <ejs-richtexteditor id="markdown" #markdown [value]="value" height='447px' [toolbarSettings]='tools' saveInterval='10' [editorMode]='mode'
                        (created)='onCreate()' (change)='onChange()' (actionComplete)='updateValue()'>
                    </ejs-richtexteditor>
                </div>
            </ng-template>
        </e-pane>
        <e-pane cssClass='pane2' min='40%'>
            <ng-template #content>
                <div class="heading right">
                    <h6 class="title"><b>Markdown Preview</b></h6>
                    <div class="splitter-default-content source-code pane2" style="padding: 20px;"></div>
                </div>
            </ng-template>
        </e-pane>
    </e-panes>
</ejs-splitter></div>`,
    providers: [ToolbarService, LinkService, ImageService, MarkdownEditorService, TableService]
})

export class AppComponent {
    @ViewChild('markdown')
    public editorObj?: RichTextEditorComponent;

    @ViewChild('splitterInstance')
    public splitterObj!: SplitterComponent;

    public textArea?: HTMLTextAreaElement;
    public mdsource?: HTMLElement;
    public mdSplit?: HTMLElement;
    public htmlPreview?: HTMLElement;
    public tools: ToolbarSettingsModel = {
        enableFloating: false,
        items: [
            'Bold',
            'Italic',
            'StrikeThrough',
            '|',
            'Formats',
            'Blockquote',
            'OrderedList',
            'UnorderedList',
            '|',
            'CreateLink',
            'Image',
            'CreateTable',
            '|',
            'Undo',
            'Redo',
        ],
    };

    public value: string =
        'In Rich Text Editor, you click the toolbar buttons to format the words and the changes are visible immediately. Markdown is not like that. When you format the word in Markdown format, you need to add Markdown syntax to the word to indicate which words and phrases should look different from each other. Rich Text Editor supports markdown editing when the editorMode set as **markdown** and using both *keyboard interaction* and *toolbar action*, you can apply the formatting to text. You can add our own custom formation syntax for the Markdown formation, [sample link](https://ej2.syncfusion.com/home/). The third-party library <b>Marked</b> is used in this sample to convert markdown into HTML content.';

    public srcArea: any;
    public mode: EditorMode = 'Markdown';

    public resizing(): void {
        this.editorObj!.refreshUI();
    }

    public updateOrientation(): void {
        debugger;
        if (Browser.isDevice) {
        (this.splitterObj as any).orientation = 'Vertical';
        (document.body.querySelector('.heading') as HTMLElement).style.width =
            'auto';
        }
    }

    public onCreate(): void {
        setTimeout(() => {
        this.editorObj!.refreshUI();
        this.textArea = (
            this.editorObj!.contentModule as ContentRender
        ).getEditPanel() as HTMLTextAreaElement;
        this.srcArea = document.querySelector('.source-code');
        this.updateValue();
        }, 0);
    }
    public onChange(): void {
        this.updateValue();
    }

    public async updateValue(): Promise<void> {
        this.srcArea.innerHTML = await marked(
        (
            (
            this.editorObj!.contentModule as ContentRender
            ).getEditPanel() as HTMLTextAreaElement
        ).value
        );
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Markdown to HTML preview in Vue Markdown Editor Component

18 Mar 202521 minutes to read

The Markdown Editor provides an instant preview of Markdown changes, allowing users to see the formatted output while typing or editing text. This enhances the editing experience by enabling real-time visualization of Markdown formatting.

Enable Markdown Preview in Vue Markdown Editor

To enable the Markdown preview feature, integrate the third-party Marked library, which converts Markdown content into HTML format. The following example demonstrates how to enable Markdown to HTML preview in the Syncfusion Vue Markdown Editor.

<template>
  <div class="control-section markdown-preview">
    <ejs-splitter
      ref="splitterObj"
      id="splitter-rte-markdown-preview"
      width="100%"
      height="450px"
      :resizing="onRefreshUI"
      :created="updateOrientation"
    >
      <e-panes>
        <e-pane
          size="50%"
          :resizable="true"
          :content="'pane1Content'"
          min="40%"
        >
          <template v-slot:pane1Content>
            <ejs-richtexteditor
              id="defaultRTE"
              ref="rteObj"
              :toolbarSettings="toolbarSettings"
              :value="value"
              height="100%"
              saveInterval="1"
              maxLength="5000"
              :created="onCreate"
              :change="onChange"
              :actionComplete="updateValue"
              :editorMode="editorMode"
            >
            </ejs-richtexteditor>
          </template>
        </e-pane>
        <e-pane :content="'pane2Content'" min="40%">
          <template v-slot:pane2Content>
            <div class="heading right">
              <h4 class="title"><b>Markdown Preview</b></h4>
              <div
                class="splitter-default-content source-code pane2"
                style="padding: 20px"
              ></div>
            </div>
          </template>
        </e-pane>
      </e-panes>
    </ejs-splitter>
  </div>
</template>

<style>

.markdown-preview .heading {
    float: left;
    width: 100%;
    position: relative;
    box-sizing: border-box;
    padding: 0px;
    border-left: none;
    border-top: none;
}
.markdown-preview .title {
    color: #333333;
    letter-spacing: 1px;
    padding-left: 10px;
    text-align: center;
    margin: 10px 0;
}
.fabric-dark .markdown-preview .title,
.bootstrap5-dark .markdown-preview .title,
.bootstrap5\.3-dark .markdown-preview .title,
.bootstrap-dark .markdown-preview .title,
.fluent-dark .markdown-preview .title,
.fluent2-dark .markdown-preview .title,
.material-dark .markdown-preview .title,
.tailwind-dark .markdown-preview .title,
.tailwind3-dark .markdown-preview .title,
.highcontrast .markdown-preview .title {
    color: #fff;
}
</style>

<script setup>
import { Browser } from '@syncfusion/ej2-base';
import {
    RichTextEditorComponent as EjsRichtexteditor,
    Toolbar,
    Link,
    Image,
    Table,
    MarkdownEditor,
  } from '@syncfusion/ej2-vue-richtexteditor';
import { SplitterComponent as EjsSplitter, PanesDirective as EPanes, PaneDirective as EPane } from '@syncfusion/ej2-vue-layouts';
import { marked } from 'marked';

const rteValue = `In Rich Text Editor, you click the toolbar buttons to format the words and the changes are visible immediately. 
                    Markdown is not like that. When you format the word in Markdown format, you need to add Markdown syntax to the word to indicate which words 
                    and phrases should look different from each other
                    
                    Rich Text Editor supports markdown editing when the editorMode set as **markdown** and using both *keyboard interaction* and *toolbar action*, you can apply the formatting to text.
                    
                    We can add our own custom formation syntax for the Markdown formation, [sample link](https://ej2.syncfusion.com/home/).
                    
                    The third-party library <b>Marked</b> is used in this sample to convert markdown into HTML content`;

const rteObj = ref(null);
const toolbarSettings = {
    items: [
        'Bold',
        'Italic',
        'StrikeThrough',
        '|',
        'Formats',
        'Blockquote',
        'OrderedList',
        'UnorderedList',
        '|',
        'CreateLink',
        'Image',
        'CreateTable',
        '|',
        'Undo',
        'Redo',
    ],
};
let textArea= null;
let srcArea= null;
const editorMode= 'Markdown';

const onCreate = () => {
    setTimeout(() => {
        this.$refs.rteObj.ej2Instances.refreshUI();
        this.textArea =
        this.$refs.rteObj.ej2Instances.contentModule.getEditPanel();
        this.srcArea = document.querySelector('.source-code');
        this.updateValue();
    }, 10);
   
};
const onChange = () => {
   this.updateValue();
};

const updateValue = () => {
   this.srcArea.innerHTML = marked(
        this.$refs.rteObj.ej2Instances.contentModule.getEditPanel().value
    );
};
const onRefreshUI = () => {
   this.$refs.rteObj.ej2Instances.refreshUI();
};

const updateOrientation = () => {
   if (Browser.isDevice) {
        this.$refs.splitterObj.$el.ej2_instances[0].orientation = 'Vertical';
        document.body.querySelector('.heading').style.width = 'auto';
    }
};
provide('richtexteditor', [Toolbar, Link, Image, Table, MarkdownEditor]);
</script>

<style>
@import "../../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-inputs/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-lists/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-navigations/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-splitbuttons/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-vue-layouts/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/material.css";
</style>
<template>
  <div class="control-section markdown-preview">
    <ejs-splitter
      ref="splitterObj"
      id="splitter-rte-markdown-preview"
      width="100%"
      height="450px"
      :resizing="onRefreshUI"
      :created="updateOrientation"
    >
      <e-panes>
        <e-pane
          size="50%"
          :resizable="true"
          :content="'pane1Content'"
          min="40%"
        >
          <template v-slot:pane1Content>
            <ejs-richtexteditor
              id="defaultRTE"
              ref="rteObj"
              :toolbarSettings="toolbarSettings"
              :value="value"
              height="100%"
              saveInterval="1"
              maxLength="5000"
              :created="onCreate"
              :change="onChange"
              :actionComplete="updateValue"
              :editorMode="editorMode"
            >
            </ejs-richtexteditor>
          </template>
        </e-pane>
        <e-pane :content="'pane2Content'" min="40%">
          <template v-slot:pane2Content>
            <div class="heading right">
              <h4 class="title"><b>Markdown Preview</b></h4>
              <div
                class="splitter-default-content source-code pane2"
                style="padding: 20px"
              ></div>
            </div>
          </template>
        </e-pane>
      </e-panes>
    </ejs-splitter>
  </div>
</template>

<style>
.markdown-preview .heading {
  float: left;
  width: 100%;
  position: relative;
  box-sizing: border-box;
  padding: 0px;
  border-left: none;
  border-top: none;
}
.markdown-preview .title {
  color: #333333;
  letter-spacing: 1px;
  padding-left: 10px;
  text-align: center;
  margin: 10px 0;
}
.fabric-dark .markdown-preview .title,
.bootstrap5-dark .markdown-preview .title,
.bootstrap5\.3-dark .markdown-preview .title,
.bootstrap-dark .markdown-preview .title,
.fluent-dark .markdown-preview .title,
.fluent2-dark .markdown-preview .title,
.material-dark .markdown-preview .title,
.tailwind-dark .markdown-preview .title,
.tailwind3-dark .markdown-preview .title,
.highcontrast .markdown-preview .title {
  color: #fff;
}
</style>

<script>

import { Browser } from '@syncfusion/ej2-base';
import {
    RichTextEditorComponent,
    Toolbar,
    Link,
    Image, Table, 
    MarkdownEditor,
  } from '@syncfusion/ej2-vue-richtexteditor';
import {
    SplitterComponent,
    PanesDirective,
    PaneDirective,
} from '@syncfusion/ej2-vue-layouts';
import { marked } from 'marked';

export default {
    name: "App",
    components: {
            'ejs-richtexteditor': RichTextEditorComponent,
            'ejs-splitter': SplitterComponent,
            'e-panes': PanesDirective,
            'e-pane': PaneDirective,
    },
    data: function() {
        return {
            textArea: null,
            srcArea: null,
            editorMode: 'Markdown',
            toolbarSettings: {
              items: [
                'Bold',
                'Italic',
                'StrikeThrough',
                '|',
                'Formats',
                'OrderedList',
                'UnorderedList',
                '|',
                'CreateLink',
                'Image',
                'CreateTable',
                '|',
                'Undo',
                'Redo',
              ],
            },
            value: `In Rich Text Editor, you click the toolbar buttons to format the words and the changes are visible immediately. 
                    Markdown is not like that. When you format the word in Markdown format, you need to add Markdown syntax to the word to indicate which words 
                    and phrases should look different from each other
                    
                    Rich Text Editor supports markdown editing when the editorMode set as **markdown** and using both *keyboard interaction* and *toolbar action*, you can apply the formatting to text.
                    
                    We can add our own custom formation syntax for the Markdown formation, [sample link](https://ej2.syncfusion.com/home/).
                    
                    The third-party library <b>Marked</b> is used in this sample to convert markdown into HTML content`,
        }
    },
    methods: {
        onCreate: function () {
            setTimeout(() => {
              this.$refs.rteObj.ej2Instances.refreshUI();
              this.textArea =
                this.$refs.rteObj.ej2Instances.contentModule.getEditPanel();
              this.srcArea = document.querySelector('.source-code');
              this.updateValue();
            }, 10);
          },
        onChange: function () {
            this.updateValue();
        },
        updateValue: function (e) {
            this.srcArea.innerHTML = marked(
                this.$refs.rteObj.ej2Instances.contentModule.getEditPanel().value
            );
        },
        onRefreshUI: function () {
            this.$refs.rteObj.ej2Instances.refreshUI();
        },
        updateOrientation: function() {
            if (Browser.isDevice) {
                this.$refs.splitterObj.$el.ej2_instances[0].orientation = 'Vertical';
                document.body.querySelector('.heading').style.width = 'auto';
            }
        },
    },
    provide:{
        richtexteditor:[Toolbar, Link, Image, MarkdownEditor, Table]
    }
}
</script>

<style>
@import "../../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-inputs/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-lists/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-navigations/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-splitbuttons/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-vue-layouts/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/material.css";
</style>

Markdown Preview in React Markdown Editor Component

4 Sep 202524 minutes to read

The Markdown Editor provides an instant preview of Markdown changes, allowing users to see the formatted output while typing or editing text. This enhances the editing experience by enabling real-time visualization of Markdown formatting.

Enable Markdown Preview in React Markdown Editor

To enable the Markdown preview feature, integrate the third-party Marked library, which converts Markdown content into HTML format. The following example demonstrates how to enable Markdown to HTML preview in the Syncfusion React Markdown Editor.example demonstrates how to enable and preview Markdown changes within the Rich Text Editor.

[Class-component]

import { Browser } from '@syncfusion/ej2-base';
import {
  Image,
  Inject,
  Link,
  MarkdownEditor,
  RichTextEditorComponent,
  Table,
  Toolbar,
  ToolbarType
} from '@syncfusion/ej2-react-richtexteditor';
import {
  PaneDirective,
  PanesDirective,
  SplitterComponent,
} from '@syncfusion/ej2-react-layouts';
import * as Marked from 'marked';
import * as React from 'react';

class App extends React.Component {
    rteObj;
    splitterInstance;
    // set the value to Rich Text Editor
    value = `In Rich Text Editor , you click the toolbar buttons to format the words and the changes are visible immediately. 
Markdown is not like that. When you format the word in Markdown format, you need to add Markdown syntax to the word to indicate which words 
and phrases should look different from each other
    
Rich Text Editor supports markdown editing when the editorMode set as **markdown** and using both *keyboard interaction* and *toolbar action*, you can apply the formatting to text.
    
We can add our own custom formation syntax for the Markdown formation, [sample link](https://ej2.syncfusion.com/home/).
    
The third-party library <b>Marked</b> is used in this sample to convert markdown into HTML content`;
    // Rich Text Editor items list
    items = ['Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList', 'UnorderedList', '|',
            'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable'];
    textArea;
    srcArea;
    placeholder = 'Enter your text here...';
    //Rich Text Editor ToolbarSettings
    toolbarSettings = {
        items: this.items,
        type: ToolbarType.Expand,
        enableFloating: false
    };
    onCreate() {
        this.textArea = this.rteObj.contentModule.getEditPanel();
        this.srcArea = document.querySelector('.source-code');
        this.updateValue();
    }
    onChange() {
        this.updateValue();
    }
    onResizing() {
        this.rteObj.refreshUI();
    }
    async updateValue() {
        this.srcArea.innerHTML = await Marked.parse(this.rteObj.contentModule.getEditPanel().value);
    }
    updateOrientation() {
        if (Browser.isDevice) {
            this.splitterInstance.orientation = 'Vertical';
            document.body.querySelector('.heading').style.width = 'auto';
        }
    }
    content1() {
        return (<div className="content">
            <RichTextEditorComponent id='defaultRTE' ref={(richtexteditor) => { this.rteObj = richtexteditor; }} editorMode='Markdown' toolbarSettings={this.toolbarSettings} height='447px' saveInterval={1} created={this.onCreate.bind(this)} change={this.onChange.bind(this)} actionComplete={this.updateValue.bind(this)} value={this.value}>
                 <Inject services={[MarkdownEditor, Toolbar, Image, Link, Table]} />
            </RichTextEditorComponent>
        </div>);
    }
    ;
    content2() {
        return (<div className="heading right">
            <h6 className="title"><b>Markdown Preview</b></h6>
            <div className="splitter-default-content source-code pane2" style=></div>
        </div>);
    }
    ;
    render() {
        return (<div id="rte-default" className='control-pane'>
                    <div className='control-section markdown-preview' id="rtePreview">
                        <div className="content-wrapper">
                        <SplitterComponent id='splitter-rte-markdown-preview' ref={splitter => (this.splitterInstance = splitter)} height='450px' width='100%' resizing={this.onResizing.bind(this)} created={this.updateOrientation.bind(this)}>
                            <PanesDirective>
                                <PaneDirective resizable={true} size='50%' min="40%" cssClass='pane1' content={this.content1.bind(this)}></PaneDirective>
                                <PaneDirective min="40%" cssClass='pane2' content={this.content2.bind(this)}></PaneDirective>
                            </PanesDirective>
                        </SplitterComponent>
                        </div>
                    </div>
                </div>);
        }
}
export default App;
import { Browser } from '@syncfusion/ej2-base';
import {
  Image,
  Inject,
  Link,
  MarkdownEditor,
  RichTextEditorComponent,
  Table,
  Toolbar,
  ToolbarType,ToolbarSettingsModel, IToolbarItems
} from '@syncfusion/ej2-react-richtexteditor';
import {
  PaneDirective,
  PanesDirective,
  SplitterComponent,
} from '@syncfusion/ej2-react-layouts';
import * as Marked from 'marked';
import * as React from 'react';

class App extends React.Component<{},{}> {
  private rteObj: RichTextEditorComponent;
  private splitterInstance;
  // set the value to Rich Text Editor
  private value: string = `In Rich Text Editor , you click the toolbar buttons to format the words and the changes are visible immediately. 
Markdown is not like that. When you format the word in Markdown format, you need to add Markdown syntax to the word to indicate which words 
and phrases should look different from each other
  
Rich Text Editor supports markdown editing when the editorMode set as **markdown** and using both *keyboard interaction* and *toolbar action*, you can apply the formatting to text.
  
We can add our own custom formation syntax for the Markdown formation, [sample link](https://ej2.syncfusion.com/home/).
  
The third-party library <b>Marked</b> is used in this sample to convert markdown into HTML content`;

  // Rich Text Editor items list
  public items: (string | IToolbarItems)[] = ['Bold', 'Italic', 'StrikeThrough', '|',
                            'Formats', 'OrderedList', 'UnorderedList', '|',
                            'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable'];
  public textArea: HTMLElement;
  public srcArea: HTMLElement;
  public placeholder: string = 'Enter your text here...';
  //Rich Text Editor ToolbarSettings
  public toolbarSettings: ToolbarSettingsModel = {
      items: this.items,
      type: ToolbarType.Expand,
      enableFloating: false
  };
  public onCreate() {
      this.textArea = this.rteObj.contentModule.getEditPanel() as HTMLElement;
      this.srcArea = document.querySelector('.source-code') as HTMLElement;
      this.updateValue();
  }
  public onChange() {
      this.updateValue();
  }
  public onResizing() {
      this.rteObj.refreshUI();
  }
  public async updateValue() {
      this.srcArea.innerHTML = await Marked.parse((this.rteObj.contentModule.getEditPanel() as HTMLTextAreaElement).value);
  }
  public updateOrientation() { 
      if (Browser.isDevice) {
          this.splitterInstance.orientation = 'Vertical';
          (document.body.querySelector('.heading') as any).style.width = 'auto';
      }
  }
  public content1() {
      return (<div className="content">
          <RichTextEditorComponent id="markdown-editor" editorMode='Markdown' ref={richtexteditor => (this.rteObj = richtexteditor)} toolbarSettings={this.toolbarSettings} height='447px' saveInterval={1} 
                      created={this.onCreate.bind(this)} 
                      change={this.onChange.bind(this)} 
                      actionComplete={this.updateValue.bind(this)} 
                      value={this.value}>
               <Inject services={[Toolbar, MarkdownEditor, Link, Image, Table]} />
          </RichTextEditorComponent>
      </div>);
  };
  public content2() {
      return (<div className="heading right">
          <h6 className="title"><b>Markdown Preview</b></h6>
          <div className="splitter-default-content source-code pane2" style=></div>
      </div>);
  };

  public render() {
    return (
      <div id="rte-default" className='control-pane'>
         <div className='control-section markdown-preview' id="rtePreview">
                    <div className="content-wrapper">
                    <SplitterComponent id='splitter-rte-markdown-preview' ref={splitter => (this.splitterInstance = splitter)} height='450px' width='100%' resizing={this.onResizing.bind(this)} created={this.updateOrientation.bind(this)}>
                        <PanesDirective>
                            <PaneDirective resizable={true} size='50%' min="40%" cssClass='pane1' content={this.content1.bind(this)}></PaneDirective>
                            <PaneDirective min="40%" cssClass='pane2' content={this.content2.bind(this)}></PaneDirective>
                        </PanesDirective>
                    </SplitterComponent>
                    </div>
                </div>
      </div>
    );
  }
}

export default App;

[Functional-component]

import { Browser } from '@syncfusion/ej2-base';
import {
  Image,
  Inject,
  Link,
  MarkdownEditor,
  RichTextEditorComponent,
  Table,
  Toolbar,
  ToolbarType,
} from '@syncfusion/ej2-react-richtexteditor';
import {
  PaneDirective,
  PanesDirective,
  SplitterComponent,
} from '@syncfusion/ej2-react-layouts';
import * as Marked from 'marked';
import * as React from 'react';

function App() {
  let rteObj;
  let splitterInstance;
  // set the value to Rich Text Editor
  const value = `In Rich Text Editor , you click the toolbar buttons to format the words and the changes are visible immediately. 
   Markdown is not like that. When you format the word in Markdown format, you need to add Markdown syntax to the word to indicate which words 
   and phrases should look different from each other
       
   Rich Text Editor supports markdown editing when the editorMode set as **markdown** and using both *keyboard interaction* and *toolbar action*, you can apply the formatting to text.
       
   We can add our own custom formation syntax for the Markdown formation, [sample link](https://ej2.syncfusion.com/home/).
       
   The third-party library <b>Marked</b> is used in this sample to convert markdown into HTML content`;
  // Rich Text Editor items list
  const items = [
    'Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList', 'UnorderedList', '|',
    'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable'
  ];
  let textArea;
  let srcArea;
  //Rich Text Editor ToolbarSettings
  const toolbarSettings = {
    items: items,
    type: ToolbarType.Expand,
    enableFloating: false,
  };
  function onCreate() {
    textArea = rteObj.contentModule.getEditPanel();
    srcArea = document.querySelector('.source-code');
    updateValue();
  }
  function onChange() {
    updateValue();
  }
  function onResizing() {
    rteObj.refreshUI();
  }
  async function updateValue() {
    if (rteObj?.contentModule) {
      srcArea.innerHTML = await Marked.parse(rteObj.contentModule.getEditPanel().value);
    }
  }
  function updateOrientation() {
    if (Browser.isDevice) {
      splitterInstance.orientation = 'Vertical';
      document.body.querySelector('.heading').style.width = 'auto';
    }
  }
  function content1() {
    return (
      <div className="content">
        <RichTextEditorComponent
          id="markdown-editor"
          ref={(richtexteditor) => {
            rteObj = richtexteditor;
          }}
          editorMode="Markdown"
          toolbarSettings={toolbarSettings}
          height="447px"
          saveInterval={1}
          created={onCreate.bind(this)}
          change={onChange.bind(this)}
          actionComplete={updateValue.bind(this)}
          value={value}
        >
          <Inject services={[MarkdownEditor, Toolbar, Image, Link, Table]} />
        </RichTextEditorComponent>
      </div>
    );
  }
  function content2() {
    return (
      <div className="heading right">
        <h6 className="title">
          <b>Markdown Preview</b>
        </h6>
        <div
          className="splitter-default-content source-code pane2"
          style=
        ></div>
      </div>
    );
  }
  return (
    <div className="control-pane">
      <div className="control-section markdown-preview" id="rtePreview">
        <div className="content-wrapper">
          <SplitterComponent
            id="splitter-rte-markdown-preview"
            ref={(splitter) => (splitterInstance = splitter)}
            height="450px"
            width="100%"
            resizing={onResizing.bind(this)}
            created={updateOrientation.bind(this)}
          >
            <PanesDirective>
              <PaneDirective
                resizable={true}
                size="50%"
                min="40%"
                cssClass="pane1"
                content={content1.bind(this)}
              ></PaneDirective>
              <PaneDirective
                min="40%"
                cssClass="pane2"
                content={content2.bind(this)}
              ></PaneDirective>
            </PanesDirective>
          </SplitterComponent>
        </div>
      </div>
    </div>
  );
}
export default App;
import { Browser } from '@syncfusion/ej2-base';
import {
  Image,
  Inject,
  Link,
  MarkdownEditor,
  RichTextEditorComponent,
  Table,
  Toolbar,
  ToolbarType,ToolbarSettingsModel, IToolbarItems
} from '@syncfusion/ej2-react-richtexteditor';
import {
  PaneDirective,
  PanesDirective,
  SplitterComponent,
} from '@syncfusion/ej2-react-layouts';
import * as Marked from 'marked';
import * as React from 'react';

function App() {
  let rteObj: RichTextEditorComponent;
  let splitterInstance;
  // set the value to Rich Text Editor
  const value: string = `In Rich Text Editor , you click the toolbar buttons to format the words and the changes are visible immediately. 
Markdown is not like that. When you format the word in Markdown format, you need to add Markdown syntax to the word to indicate which words 
and phrases should look different from each other
    
Rich Text Editor supports markdown editing when the editorMode set as **markdown** and using both *keyboard interaction* and *toolbar action*, you can apply the formatting to text.
    
We can add our own custom formation syntax for the Markdown formation, [sample link](https://ej2.syncfusion.com/home/).
    
The third-party library <b>Marked</b> is used in this sample to convert markdown into HTML content`;
  // Rich Text Editor items list
  const items: (string | IToolbarItems)[] = ['Bold', 'Italic', 'StrikeThrough', '|',
                            'Formats', 'OrderedList', 'UnorderedList', '|',
                            'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable'];
  let textArea: HTMLElement;
  let srcArea: Element;
  //Rich Text Editor ToolbarSettings
  const toolbarSettings: ToolbarSettingsModel = {
      items: items,
      type: ToolbarType.Expand,
      enableFloating: false
  };
  function onCreate() {
      textArea = rteObj.contentModule.getEditPanel() as HTMLElement;
      srcArea = document.querySelector('.source-code') as HTMLElement;
      updateValue();
  }
  function onChange() {
      updateValue();
  }
  function onResizing() {
      rteObj.refreshUI();
  }
  async function updateValue() {
      srcArea.innerHTML = await Marked.parse((rteObj.contentModule.getEditPanel() as HTMLTextAreaElement).value);
  }
  function updateOrientation() { 
      if (Browser.isDevice) {
          splitterInstance.orientation = 'Vertical';
          (document.body.querySelector('.heading') as any).style.width = 'auto';
      }
  }
  function content1() {
      return (<div className="content">
          <RichTextEditorComponent id='markdown-editor' ref={(richtexteditor) => { rteObj = richtexteditor; }} editorMode='Markdown'  toolbarSettings={toolbarSettings} height='447px' saveInterval={1} created={onCreate.bind(this)} change={onChange.bind(this)} actionComplete={updateValue.bind(this)} value={value}>
              <Inject services={[MarkdownEditor, Toolbar, Image, Link, Table]} />
          </RichTextEditorComponent>
      </div>);
  };
  function content2() {
      return (<div className="heading right">
          <h6 className="title"><b>Markdown Preview</b></h6>
          <div className="splitter-default-content source-code pane2" style=></div>
      </div>);
  };
  return (
      <div className='control-pane'>
          <div className='control-section markdown-preview' id="rtePreview">
              <div className="content-wrapper">
              <SplitterComponent id='splitter-rte-markdown-preview' ref={splitter => (splitterInstance = splitter)} height='450px' width='100%' resizing={onResizing.bind(this)} created={updateOrientation.bind(this)}>
                      <PanesDirective>
                          <PaneDirective resizable={true} size='50%' min="40%" cssClass='pane1' content={content1.bind(this)}></PaneDirective>
                          <PaneDirective min="40%" cssClass='pane2' content={content2.bind(this)}></PaneDirective>
                      </PanesDirective>
                  </SplitterComponent>
              </div>
          </div>
      </div>
  );
}
export default App;